#include "stdafx.h"
#include <shlwapi.h>
#include "ScheduleRec.h"
#include "TsStreamEngine/TsStream.h"
#include "resource.h"

// Ԏwł̐VKǉ
BOOL CScheduleRec::OnScheduleAdd_ByDateTime(BOOL bSetData,WORD wServiceID,DateTime *pstStart,DWORD dwRecTime,char *lpszName)
{
	if(m_hEditWnd) return FALSE;
	// VK쐬pf[^̍쐬(ݎ`ROW)
	ZeroMemory(&m_stEditItem,sizeof(m_stEditItem));
	m_stEditItem.dwFlg = SCHEDULE_FLAG_DATETIME;
	lstrcpy(m_stEditItem.szDir,m_szPath);	
	if(bSetData && pstStart)
	{
		m_stEditItem.dwFlg |= SCHEDULE_FLAG_SERVICE_ID;
		wsprintf(m_stEditItem.szServiceID,"%d",wServiceID);
		m_stEditItem.stTime.stStart=*pstStart;
		m_stEditItem.stTime.dwRecSec=dwRecTime;
		long year,month,day,hour,min,sec;
		CDateTime::ConvertFrom_MJD(pstStart->Date,year,month,day);
		CDateTime::ConvertFrom_TimeSec(pstStart->Time,hour,min,sec);
		wsprintf(m_stEditItem.szFile,"%04d%02d%02d-%02d%02d",year,month,day,hour,min);
	} else {
		m_stEditItem.stTime.stStart=CDateTime::GetCurrentDateTime();
		m_stEditItem.stTime.dwRecSec=30*60;
		long year,month,day,hour,min,sec;
		CDateTime::ConvertFrom_MJD(m_stEditItem.stTime.stStart.Date,year,month,day);
		CDateTime::ConvertFrom_TimeSec(m_stEditItem.stTime.stStart.Time,hour,min,sec);
		wsprintf(m_stEditItem.szFile,"%04d%02d%02d-%02d%02d",year,month,day,hour,min);
	}		
	if(lpszName)
	{
		m_stEditItem.dwFlg |= SCHEDULE_FLAG_USERFILENAME;
		lstrcat(m_stEditItem.szFile,"-");
		lstrcat(m_stEditItem.szFile,lpszName);
	}
	lstrcpy(m_stEditItem.szExt,".ts");
	INT_PTR ret = DialogBoxParam(m_hInst,MAKEINTRESOURCE(IDD_SCHEDULE_EDIT),m_hWnd,reinterpret_cast<DLGPROC>(_ScheduleEditDlg),reinterpret_cast<LPARAM>(this));
	return ret==IDOK;
}

// Cxghcł̐VKǉ
BOOL CScheduleRec::OnScheduleAdd_ByEvent(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID)
{
	if(m_hEditWnd) return FALSE;
	// VK쐬pf[^̍쐬
	ZeroMemory(&m_stEditItem,sizeof(m_stEditItem));
	m_stEditItem.dwFlg = SCHEDULE_FLAG_EVENTID;
	m_stEditItem.stEvent.wNetworkID=wNetworkID;
	m_stEditItem.stEvent.wStreamID=wStreamID;
	m_stEditItem.stEvent.wServiceID=wServiceID;
	m_stEditItem.stEvent.wEventID=wEventID;
	INT_PTR ret = DialogBoxParam(m_hInst,MAKEINTRESOURCE(IDD_SCHEDULE_EDIT),m_hWnd,reinterpret_cast<DLGPROC>(_ScheduleEditDlg),reinterpret_cast<LPARAM>(this));
	return ret==IDOK;
}

// Ԏwł̐VKǉ
BOOL CScheduleRec::OnScheduleEdit(struct ScheduleRecItem &stEditItem)
{
	m_stEditItem = stEditItem;
	INT_PTR ret = DialogBoxParam(m_hInst,MAKEINTRESOURCE(IDD_SCHEDULE_EDIT),m_hWnd,reinterpret_cast<DLGPROC>(_ScheduleEditDlg),reinterpret_cast<LPARAM>(this));
	if(ret==IDOK)
	{
		stEditItem = m_stEditItem;
		return TRUE;
	}
	return FALSE;
}


// ^\p_CAO
LRESULT CScheduleRec::ScheduleEditDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		{
			m_hEditWnd=hDlg;
			return OnScheduleEditInitDialog(hDlg);
		}
		break;
	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case IDOK:
				{
					struct ScheduleRecItem stNew;
					if(!GetDataFromDlg(hDlg,stNew)) return FALSE;
					m_stEditItem = stNew;
				}
				// breakĂȂ͈̂Ӑ}IȂ
			case IDCANCEL:
				{
					EndDialog(hDlg,LOWORD(wParam));
					m_hEditWnd=NULL;
				}
				break;
			}
		}
		break;
	}
	return FALSE;
}

BOOL CScheduleRec::OnScheduleEditInitDialog(HWND hWnd)
{
	LRESULT posDate,posEventID,pos;

	// ^Cv
	SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_RESETCONTENT,0,0);
	posDate   =SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_ADDSTRING,0,(LPARAM)"w");	
	posEventID=SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_ADDSTRING,0,(LPARAM)"Cxgw");
	SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_SETITEMDATA,posDate   ,0);
	SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_SETITEMDATA,posEventID,1);
	EnableWindow(GetDlgItem(hWnd,IDC_SCHEDULE_TYPE),FALSE);
	// 
	SYSTEMTIME stTime;
	long year,mon,day,h,m,s;
	ZeroMemory(&stTime,sizeof(stTime));
	DateTime_GetSystemtime(GetDlgItem(hWnd,IDC_STARTDATE),&stTime);
	CDateTime::ConvertFrom_MJD(m_stEditItem.stTime.stStart.Date,year,mon,day);
	stTime.wYear=(WORD)year;
	stTime.wMonth=(WORD)mon;
	stTime.wDay=(WORD)day;
	DateTime_SetFormat(GetDlgItem(hWnd,IDC_STARTDATE),"yyyyNMMdd");
	DateTime_SetSystemtime(GetDlgItem(hWnd,IDC_STARTDATE),GDT_VALID,&stTime);
	CDateTime::ConvertFrom_TimeSec(m_stEditItem.stTime.stStart.Time,h,m,s);
	stTime.wHour=(WORD)h;
	stTime.wMinute=(WORD)m;
	stTime.wSecond=(WORD)s;
	DateTime_SetFormat(GetDlgItem(hWnd,IDC_STARTTIME),"HHmmssb");
	DateTime_SetSystemtime(GetDlgItem(hWnd,IDC_STARTTIME),GDT_VALID,&stTime);
	CDateTime::ConvertFrom_TimeSec(m_stEditItem.stTime.dwRecSec,h,m,s);
	stTime.wHour=(WORD)h;
	stTime.wMinute=(WORD)m;
	stTime.wSecond=(WORD)s;
	DateTime_SetFormat(GetDlgItem(hWnd,IDC_RECORDTIME),"HHmmssb");
	DateTime_SetSystemtime(GetDlgItem(hWnd,IDC_RECORDTIME),GDT_VALID,&stTime);
	// ^Cv
	if(m_stEditItem.dwFlg&SCHEDULE_FLAG_DATETIME)
	{
		SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_SETCURSEL,posDate,0);
		// `l
		if(m_pDTV->GetExtFunction()&DTV_EXTFUNC_CHSEL && m_pDTV->GetChannelCount()>0)
		{
			pos=SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_ADDSTRING,0,(LPARAM)"Ȃ");
			SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_SETITEMDATA,pos,-1);
			int i,n=m_pDTV->GetChannelCount();
			for(i=0;i<n;i++)
			{
				char buf[80];
				int val=m_pDTV->GetChannelName(i,buf,80);
				pos=SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_ADDSTRING,0,(LPARAM)buf);
				SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_SETITEMDATA,pos,val);
			}
			SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_SETCURSEL,0,0);
		} else {
			pos=SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_ADDSTRING,0,(LPARAM)"");	
			SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_SETITEMDATA,pos,-1);
			SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_SETCURSEL,pos,0);
			EnableWindow(GetDlgItem(hWnd,IDC_CHANNEL),FALSE);
		}
		if(m_pDTV->GetExtFunction()&DTV_EXTFUNC_CHSTR)
		{
			SetDlgItemText(hWnd,IDC_CHANNEL_STR,m_stEditItem.szChannnelStr);
		} else {
			SetDlgItemText(hWnd,IDC_CHANNEL_STR,"");
			EnableWindow(GetDlgItem(hWnd,IDC_CHANNEL_STR),FALSE);
		}
		// T[rX
		CheckDlgButton(hWnd,IDC_SERVICE_LIMIT,m_stEditItem.dwFlg&SCHEDULE_FLAG_SERVICE_ID?BST_CHECKED:BST_UNCHECKED);
		SetDlgItemText(hWnd,IDC_SERVICE_ID,m_stEditItem.szServiceID);
		// I
		pos=SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_ADDSTRING,0,(LPARAM)"\폜");
		SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_SETITEMDATA,pos,0);
		SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_SETCURSEL,pos,0);
		pos=SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_ADDSTRING,0,(LPARAM)"̓ԑтɗ\");
		SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_SETITEMDATA,pos,1);
		pos=SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_ADDSTRING,0,(LPARAM)"T̓ԑтɗ\");
		SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_SETITEMDATA,pos,2);

		// _~[ID(ӖȂ)
		EnableWindow(GetDlgItem(hWnd,IDC_IDS),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_EVENTID),FALSE);
		SetDlgItemText(hWnd,IDC_IDS,"0x0000/0x0000/0x0000");
		SetDlgItemText(hWnd,IDC_EVENTID,"0x0000");
	}
	else if(m_stEditItem.dwFlg&SCHEDULE_FLAG_EVENTID)
	{
		SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_SETCURSEL,posEventID,0);
		// tύX֎~
		EnableWindow(GetDlgItem(hWnd,IDC_STARTDATE),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_STARTTIME),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_RECORDTIME),FALSE);
		// `l͑I𖳌
		pos=SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_ADDSTRING,0,(LPARAM)"");	
		SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_SETITEMDATA,0,-1);
		SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_SETCURSEL,pos,0);
		EnableWindow(GetDlgItem(hWnd,IDC_CHANNEL),FALSE);
		SetDlgItemText(hWnd,IDC_CHANNEL_STR,"");
		EnableWindow(GetDlgItem(hWnd,IDC_CHANNEL_STR),FALSE);
		// ID
		char buf[20];
		wsprintf(buf,"0x%04X/0x%04X/0x%04X",m_stEditItem.stEvent.wNetworkID,m_stEditItem.stEvent.wStreamID,m_stEditItem.stEvent.wServiceID);
		SetDlgItemText(hWnd,IDC_IDS,buf);
		wsprintf(buf,"0x%04X",m_stEditItem.stEvent.wEventID);
		SetDlgItemText(hWnd,IDC_EVENTID,buf);
		EnableWindow(GetDlgItem(hWnd,IDC_IDS),FALSE);		
	} else {
		return FALSE;
	}
	CheckDlgButton(hWnd,IDC_USE_PATH,m_stEditItem.dwFlg&SCHEDULE_FLAG_USERFILENAME?BST_CHECKED:BST_UNCHECKED);
	SetDlgItemText(hWnd,IDC_PATH,m_stEditItem.szDir);
	SetDlgItemText(hWnd,IDC_FILENAME,m_stEditItem.szFile);
	SetDlgItemText(hWnd,IDC_FILEEXT,m_stEditItem.szExt);

	return TRUE;
}

BOOL CScheduleRec::GetDataFromDlg(HWND hWnd,struct ScheduleRecItem &stItem)
{
	ZeroMemory(&stItem,sizeof(stItem));
	LRESULT pos,item;
	pos = SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_GETCURSEL,0,0);
	if(pos==LB_ERR) return FALSE;
	item= SendDlgItemMessage(hWnd,IDC_SCHEDULE_TYPE,CB_GETITEMDATA,pos,0);
	if(item==0)
	{		
		// t[h
		DWORD dwFlg=SCHEDULE_FLAG_DATETIME;
		SYSTEMTIME stTime;
		DateTime_GetSystemtime(GetDlgItem(hWnd,IDC_STARTDATE),&stTime);
		stItem.stTime.stStart.Date=CDateTime::ConvertTo_MJD(stTime.wYear,stTime.wMonth,stTime.wDay);
		DateTime_GetSystemtime(GetDlgItem(hWnd,IDC_STARTTIME),&stTime);
		stItem.stTime.stStart.Time=CDateTime::ConvertTo_TimeSec(stTime.wHour,stTime.wMinute,+stTime.wSecond);
		DateTime_GetSystemtime(GetDlgItem(hWnd,IDC_RECORDTIME),&stTime);
		stItem.stTime.dwRecSec=CDateTime::ConvertTo_TimeSec(stTime.wHour,stTime.wMinute,+stTime.wSecond);
		if(m_pDTV->GetExtFunction()&DTV_EXTFUNC_CHSEL)
		{
			pos = SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_GETCURSEL,0,0);
			if(pos!=-1)
			{
				item= SendDlgItemMessage(hWnd,IDC_CHANNEL,CB_GETITEMDATA,pos,0);
				if(item!=-1)
				{
					dwFlg|=SCHEDULE_FLAG_CHANNEL;
					stItem.byChannel=static_cast<BYTE>(item);
				}
			}
		}
		if(m_pDTV->GetExtFunction()&DTV_EXTFUNC_CHSTR)
		{
			dwFlg|=SCHEDULE_FLAG_CHANNEL_STR;
			GetDlgItemText(hWnd,IDC_CHANNEL_STR,stItem.szChannnelStr,80);
		}
		dwFlg|=(IsDlgButtonChecked(hWnd,IDC_SERVICE_LIMIT) == BST_CHECKED ? SCHEDULE_FLAG_SERVICE_ID : 0);
		GetDlgItemText(hWnd,IDC_SERVICE_ID,stItem.szServiceID,100);

		LRESULT pos = SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_GETCURSEL,0,0);
		LRESULT dat = SendDlgItemMessage(hWnd,IDC_FINISH_AFTER,CB_GETITEMDATA,pos,0);
		switch(dat)
		{
		case 1:
			dwFlg|=SCHEDULE_FLAG_NEXTDAY;
			break;
		case 2:
			dwFlg|=SCHEDULE_FLAG_NEXTWEEK;
			break;
		}
		dwFlg|=(IsDlgButtonChecked(hWnd,IDC_USE_PATH) == BST_CHECKED ? SCHEDULE_FLAG_USERFILENAME : 0);
		GetDlgItemText(hWnd,IDC_PATH,stItem.szDir,MAX_PATH);
		GetDlgItemText(hWnd,IDC_FILENAME,stItem.szFile,MAX_PATH);
		GetDlgItemText(hWnd,IDC_FILEEXT,stItem.szExt,MAX_PATH);

		if(lstrlen(stItem.szDir)+lstrlen(stItem.szFile)+lstrlen(stItem.szExt)>MAX_PATH-2)
		{
			MessageBox(hWnd,"pX܂","",MB_OK);
			return FALSE;
		}
		if(GetFileAttributes(stItem.szDir)==INVALID_FILE_ATTRIBUTES)
		{
			MessageBox(hWnd,"ȃpXłB","",MB_OK);
			return FALSE;
		}

		stItem.dwFlg=dwFlg;
	}
	else if(item==1)
	{
		// CxgID[h
	}
	else
	{
		return FALSE;
	}

	return TRUE;
}